import inspect
from run import Task


class FunctionTask(Task):

    # Public

    def __init__(self, __function, *args, **kwargs):
        self.__function = __function
        super().__init__(*args, **kwargs)

    @property
    def meta_docstring(self):
        default = str(inspect.getdoc(self.__function)).strip()
        return self.meta_inspect('docstring', default=default)

    def meta_invoke(self, *args, **kwargs):
        return self.__function(*args, **kwargs)

    @property
    def meta_signature(self):
        default = str(inspect.signature(self.__function))
        return self.meta_inspect('signature', default=default)
